header {


version(ANTLR_TokenTypes)
{}
else
{
  private import RewriteTokenTypes;   // TODO
}

}



options {
    language = "DLang";
}



class Rewrite extends Lexer;
{
    private import std.string;
}


// protected in Java but does not work for D
START
options {
	ignore=WS;
}
	:	id:ID ":="! '('! expr:EXPR ')'!
		{
			// can access text matched for any rule
			System.outp.println("found "~id.getText()~","~expr.getText());
			// text will be ID+EXPR minus whitespace
		}
	;

protected
ID	:	( let:LETTER {System.outp.println("letter "~let.getText());} )+
	;

protected
LETTER
	:	'a'..'z'
		{
		char[] s = $getText.toString();		// get access text of this rule
		$setText(asWString(toupper(s)));	// can reset it too
		}
	;

protected
EXPR:	i:INT!	// don't include, but i.getText() has access
		{$setText(i.getText());} // effect is if no "!" and no "i:"
	|	ID
	;

protected
INT	:	('0'..'9')+
	;

// what if ! on rule itself and invoker had !...should
// rule return anything in the token to the invoker?  NO!
// make sure 'if' is in the right spot
// What about no ! on caller but ! on called rule?
protected
WS!	:	(	' '			// whitespace not saved
		|	'\t'
		|	'\n' {newline();}
		)+
		{$setType(Token.SKIP);}		// way to set token type
	;


