import os,sys

from distutils.core import setup

dstdir = 'C:\\Programme\\antlr\\275\\extras'

moddir = None

for d in [ dstdir ] :
   moddir = d
   for f in [ '__init__.py','antlr.py' ] :
      if moddir :
         x = '%s/%s' % (moddir,f)
         if not os.path.exists(x) :
            sys.stderr.write('notice: %s does not exist - going to skip dir %s\n' % (x,moddir))
            sys.stderr.flush()
            moddir = None
   if moddir:
      break

if not moddir:
   sys.stderr.write('error: unable to find module antlr.\n')
   sys.stderr.flush()
   sys.exit(1)

setup(name='antlr',
      version='2.7.5',
      description='Python runtime support for ANTLR-generated parsers',
      author='Wolfgang Haefelinger / Marq Kole',
      author_email='ora.et.labora@web.de',
      url='http://www.antlr.org',
      packages=['antlr'],
      package_dir={'antlr' : moddir }
     )
